﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TSPForm
{
    public partial class FrmACO : Form
    {
        FrmTSPSolver frmTSPSolver;//parent form of this form
        public FrmACO(FrmTSPSolver frmTSPSolver)
        {
            this.frmTSPSolver = frmTSPSolver;
            InitializeComponent();
        }

        private void FrmACO_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Dispose();//clearn up all resources used 
        }

        private void btnCancle_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnBeginACO_Click(object sender, EventArgs e)
        {
            #region Paramters Check
            if (textBoxParameterAntMount.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Ant Count! ");
                textBoxParameterAntMount.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.im = int.Parse(textBoxParameterAntMount.Text.Trim());
                    if (CAppParamter.im <1)
                    {
                        MessageBox.Show("Parameter of Ant Count must be bigger than one or equal to one !");
                        textBoxParameterAntMount.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Ant Count! " );
                    textBoxParameterAntMount.Focus();
                    return;
                }
            }

            if (textBoxParameterAlpha.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Huristic coefficient ! ");
                textBoxParameterAlpha.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.dAlpha = float.Parse(textBoxParameterAlpha.Text.Trim());
                    if (CAppParamter.dAlpha <=0)
                    {
                        MessageBox.Show("Parameter of Huristic coefficient must be bigger  than zero ! ");
                        textBoxParameterAntMount.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Huristic coefficient !" );
                    textBoxParameterAlpha.Focus();
                    return;
                }
            }

            if (textBoxParameterBeta.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Expectation Coefficient ! ");
                textBoxParameterBeta.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.dBeta = float.Parse(textBoxParameterBeta.Text.Trim());
                    if (CAppParamter.dBeta <= 0)
                    {
                        MessageBox.Show("Parameter of Expectation Coefficient must be bigger  than zero !");
                        textBoxParameterBeta.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Expectation Coefficient !");
                    textBoxParameterBeta.Focus();
                    return;
                }
            }

            if (textBoxParameterRho.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Information Volatilization ! ");
                textBoxParameterRho.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.dRho = float.Parse(textBoxParameterRho.Text.Trim());
                    if (CAppParamter.dRho >= 1 || CAppParamter.dRho < 0)
                    {
                        MessageBox.Show("Parameter of Information Volatilization overstep the range!");
                        textBoxParameterRho.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Information Volatilization !" );
                    textBoxParameterRho.Focus();
                    return;
                }
            }

            if (textBoxParameterQ.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Pheromone Intensity ! ");
                textBoxParameterQ.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.dQ = float.Parse(textBoxParameterQ.Text.Trim());
                    if ( CAppParamter.dQ <= 0)
                    {
                        MessageBox.Show("Parameter of Pheromone Intensity must be bigger than zero !");
                        textBoxParameterQ.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Pheromone Intensity ! " );
                    textBoxParameterQ.Focus();
                    return;
                }
            }

            if (textBoxCconst.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of  Pheromone Const ! ");
                textBoxCconst.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.dC = float.Parse(textBoxCconst.Text.Trim());
                    if (CAppParamter.dC <= 0)
                    {
                        MessageBox.Show("Parameter of  Pheromone Const must be bigger  than zero!");
                        textBoxCconst.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Pheromone Const ! ");
                    textBoxCconst.Focus();
                    return;
                }
            }


            if (textBoxParameterNcMax.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of Iteration Count! ");
                textBoxParameterNcMax.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.iNcMax = int.Parse(textBoxParameterNcMax.Text.Trim());
                    if (CAppParamter.iNcMax < 1)
                    {
                        MessageBox.Show("Parameter of Iteration Count must be bigger than one or equal to one !");
                        textBoxParameterNcMax.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter of Iteration Count! ");
                    textBoxParameterNcMax.Focus();
                    return;
                }
            }

            if (radioButtonUseRandom.Checked ==true)
            {
                CAppParamter.iStartCityNo = -1;
            }
            else if (radioButtonUseSet.Checked)
            {
                if (textBoxStartIndex.Text.Trim().Length <= 0)
                {
                    MessageBox.Show("Please input the Parameter of start index of TSP! ");
                    textBoxStartIndex.Focus();
                    return;
                }
                else
                {
                    try
                    {
                        CAppParamter.iStartCityNo = int.Parse(textBoxStartIndex.Text.Trim());
                        if (CAppParamter.iStartCityNo < 1 || CAppParamter.iStartCityNo>CAppParamter.iCityCount)
                        {
                            MessageBox.Show("the parameter of start index must be bigger than one \n or must be smaller than the maximum count of cities !");
                            textBoxStartIndex.Focus();
                            return;
                        }
                    }
                    catch (System.Exception ex)
                    {
                        MessageBox.Show("Please check out the Parameter of start index! ");
                        textBoxStartIndex.Focus();
                        return;
                    }
                }
            }
            #endregion

            //begin Calculate-code
            frmTSPSolver.BenginACOThread();
            this.Close();
        }

        private void radioButtonUseSet_CheckedChanged(object sender, EventArgs e)
        {
            textBoxStartIndex.Enabled = radioButtonUseSet.Checked;
        }

        private void FrmACO_Load(object sender, EventArgs e)
        {

        }
    }
}
